diff -uNrd ircd-hybrid-6.0/src/m_server.c ircd-pi1.0a/src/m_server.c
--- ircd-hybrid-6.0/src/m_server.c	Fri Nov 24 13:24:37 2000
+++ ircd-pi1.0a/src/m_server.c	Fri May 10 23:49:05 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_server.c,v 1.10 2000/11/24 18:24:37 lusky Exp $
+ *   $Id: m_server.c,v 1.7 2002/05/11 03:49:05 smoli Exp $
  */
 #include "m_commands.h"  /* m_server prototype */
 #include "client.h"      /* client struct */
@@ -36,9 +36,11 @@
 #include "scache.h"      /* find_or_add */
 #include "send.h"        /* sendto_one */
 #include "struct.h"      /* bleah */
+#include "config.h"
 
 #include <string.h>
 #include <stdlib.h>
+#include <time.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -114,7 +116,12 @@
   struct Client*   bcptr;
   struct ConfItem* aconf;
   int              hop;
-
+#ifdef HAVE_SSL
+  int              is_ssl = 0;
+#endif
+#ifdef BACKUP
+  int              main_reconn;
+#endif
   info[0] = '\0';
   /*  inpath = get_client_name(cptr,FALSE); */
   if (parc < 2 || *parv[1] == '\0')
@@ -127,6 +134,12 @@
   if (parc > 3 && atoi(parv[2]))
     {
       hop = atoi(parv[2]);
+
+#ifdef HAVE_SSL
+      if(irclen(parv[2]) && parv[2][irclen(parv[2]) - 1] == 'S')
+        is_ssl++;
+#endif      
+      
       strncpy_irc(info, parv[3], REALLEN);
       info[REALLEN] = '\0';
     }
@@ -137,7 +150,7 @@
        */
       strncpy_irc(info, parv[2], REALLEN);
       info[REALLEN] = '\0';
-      if ((parc > 3) && ((i = strlen(info)) < (REALLEN - 2)))
+      if ((parc > 3) && ((i = irclen(info)) < (REALLEN - 2)))
         {
           strcat(info, " ");
           strncat(info, parv[3], REALLEN - i - 2);
@@ -151,12 +164,12 @@
    * cleanup of host name, so a cleaned up hostname
    * can be returned as an error if necessary. - Dianora
    *
-   * yes, the if(strlen) below is really needed!! 
+   * yes, the if(irclen) below is really needed!! 
    */
-  if (strlen(host) > HOSTLEN)
+  if (irclen(host) > HOSTLEN)
     host[HOSTLEN] = '\0';
 
-  if (IsPerson(sptr))
+  if(IsPerson(sptr))
     {
       /*
        * a USER tries something fishy... ;-)
@@ -337,6 +350,14 @@
           return exit_client(cptr, cptr, cptr, "Too many servers");
         }
 
+#ifdef BACKUP
+      if(host && ((main_link = find_conf_main_link()) != NULL) &&
+        irccmp(main_link->host, host) == 0)
+        
+      if((main_reconn = backup_regain_link(cptr)))
+        return main_reconn;
+#endif /* BACKUP */
+
       acptr = make_client(cptr);
       make_server(acptr);
       acptr->hopcount = hop;
@@ -370,10 +391,12 @@
             }
           if (match(my_name_for_link(me.name, aconf), acptr->name))
             continue;
-
-          sendto_one(bcptr, ":%s SERVER %s %d :%s",
-                     parv[0], acptr->name, hop + 1, acptr->info);
-                         
+          
+#ifdef HAVE_SSL
+          sendto_one(bcptr, ":%s SERVER %s %d%s :%s",
+                     parv[0], acptr->name, hop + 1,
+                     (IsSSLServ(bcptr) && IsSSLServ(acptr)) ? "S" : "", acptr->info);
+#endif                         
         }
       
       sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
@@ -415,5 +438,3 @@
               get_client_host(cptr));
   return exit_client(cptr, cptr, cptr, "No C/N conf lines");
 }
-
-
diff -uNrd ircd-hybrid-6.0/src/m_set.c ircd-pi1.0a/src/m_set.c
--- ircd-hybrid-6.0/src/m_set.c	Wed Oct 13 22:48:25 1999
+++ ircd-pi1.0a/src/m_set.c	Fri Nov  2 19:23:34 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_set.c,v 1.4 1999/10/14 02:48:25 lusky Exp $
+ *   $Id: m_set.c,v 1.1.1.1 2001/11/03 00:23:34 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_spoof.c ircd-pi1.0a/src/m_spoof.c
--- ircd-hybrid-6.0/src/m_spoof.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/m_spoof.c	Thu May 23 12:06:25 2002
@@ -0,0 +1,87 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_spoof.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  $Id: m_spoof.c,v 1.4 2002/05/23 16:06:25 shifty Exp $
+ */
+
+#include "client.h"
+#include "numeric.h"
+#include "ircd.h"
+#include "s_user.h"
+#include "send.h"
+
+#include <string.h>
+
+/*
+ * m_spoof()
+ *
+ * parv[0] = sender prefix
+ * parv[1] = new hostname
+ *
+ */
+int     m_spoof(struct Client *cptr,
+                struct Client *sptr,
+                int parc,
+                char *parv[])
+{
+  if(MyConnect(sptr))
+    { 
+      if(!IsOper(sptr) && !IsServer(cptr))
+        {
+          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+          return 0;
+        }
+  
+      if(parc < 2)
+        {
+          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                     me.name, parv[0], "SPOOF");
+          return 0;
+        }
+  
+      if(sptr->user->spoofed)
+        {
+          sendto_one(sptr, ":%s NOTICE %s :You already spoofed your hostname.", me.name, parv[0]);
+          return 0;
+        }
+      
+      if(!valid_hostname(parv[1]))
+        {
+          sendto_one(sptr, ":%s NOTICE %s :'%s' is not a valid hostname", me.name, parv[0], parv[1]);
+          return 0;
+        }
+      
+    }
+  
+#ifdef SPOOF_NOTICE    
+  sendto_realops("Spoofing hostname '%s' for user %s [%s@%s]",
+                 parv[1], sptr->name, sptr->username, sptr->host);
+#endif  
+  
+  sendto_serv_butone(cptr, ":%s SPOOF :%s", parv[0], parv[1]);
+  
+  strncpy(sptr->host, parv[1], HOSTLEN);
+  sptr->host[HOSTLEN] = '\0';
+  sptr->user->spoofed++;
+  
+  return 1;
+}
diff -uNrd ircd-hybrid-6.0/src/m_squit.c ircd-pi1.0a/src/m_squit.c
--- ircd-hybrid-6.0/src/m_squit.c	Sat Jul 31 04:23:00 1999
+++ ircd-pi1.0a/src/m_squit.c	Fri Nov  2 19:23:34 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_squit.c,v 1.3 1999/07/31 08:23:00 tomh Exp $
+ *   $Id: m_squit.c,v 1.1.1.1 2001/11/03 00:23:34 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_stats.c ircd-pi1.0a/src/m_stats.c
--- ircd-hybrid-6.0/src/m_stats.c	Sat Dec 30 19:12:00 2000
+++ ircd-pi1.0a/src/m_stats.c	Wed May 22 12:19:42 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_stats.c,v 1.9 2000/12/31 00:12:00 lusky Exp $
+ *  $Id: m_stats.c,v 1.2 2002/05/22 16:19:42 smoli Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "class.h"       /* report_classes */
@@ -43,6 +43,7 @@
 #include "s_serv.h"      /* hunt_server, show_servers */
 #include "s_stats.h"     /* tstats */
 #include "s_user.h"      /* show_opers */
+#include "ssl.h"
 
 #include <string.h>
 
@@ -329,6 +330,59 @@
       valid_stats++;
       break;
 
+#ifdef HAVE_SSL
+    case 'J' : case 'j' :
+      if(!IsAnOper(sptr))
+        {
+          ignore_request++;
+          valid_stats++;
+          break;
+        }
+      
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_number(server_ctx) +
+                                   SSL_CTX_sess_number(client_ctx),
+                                   "items in the session cache");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_connect(server_ctx) +
+                                   SSL_CTX_sess_connect(client_ctx),
+                                   "client connects");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_connect_good(server_ctx) +
+                                   SSL_CTX_sess_connect_good(client_ctx),
+                                   "client connects that finished");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_connect_renegotiate(server_ctx) +
+                                   SSL_CTX_sess_connect_renegotiate(client_ctx),
+                                   "client renegotiatations requested");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_accept(server_ctx) +
+                                   SSL_CTX_sess_accept(client_ctx),
+                                   "server connects");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_accept_good(server_ctx) +
+                                   SSL_CTX_sess_accept_good(client_ctx),
+                                   "server connects that finished");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_accept_renegotiate(server_ctx) +
+                                   SSL_CTX_sess_accept_renegotiate(client_ctx),
+                                   "server renegotiatations requested");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_hits(server_ctx) +
+                                   SSL_CTX_sess_hits(client_ctx),
+                                   "session cache hits");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_misses(server_ctx) +
+                                   SSL_CTX_sess_misses(client_ctx),
+                                   "session cache misses");
+      sendto_one(sptr, form_str(RPL_STATSSSL),
+                 me.name, parv[0], SSL_CTX_sess_timeouts(server_ctx) +
+                                   SSL_CTX_sess_timeouts(client_ctx),
+                                   "session cache timeouts");      
+      valid_stats++;
+      break;
+#endif
+      
     case 'k' :
 #ifdef K_LINES_OPER_ONLY
       if (!IsAnOper(sptr)) 
diff -uNrd ircd-hybrid-6.0/src/m_svinfo.c ircd-pi1.0a/src/m_svinfo.c
--- ircd-hybrid-6.0/src/m_svinfo.c	Tue Oct 17 02:20:50 2000
+++ ircd-pi1.0a/src/m_svinfo.c	Fri Nov  2 19:23:34 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_svinfo.c,v 1.4 2000/10/17 06:20:50 lusky Exp $
+ *   $Id: m_svinfo.c,v 1.1.1.1 2001/11/03 00:23:34 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_time.c ircd-pi1.0a/src/m_time.c
--- ircd-hybrid-6.0/src/m_time.c	Fri Jul 30 02:40:16 1999
+++ ircd-pi1.0a/src/m_time.c	Fri Nov  2 19:23:34 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_time.c,v 1.1 1999/07/30 06:40:16 tomh Exp $
+ *   $Id: m_time.c,v 1.1.1.1 2001/11/03 00:23:34 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_trace.c ircd-pi1.0a/src/m_trace.c
--- ircd-hybrid-6.0/src/m_trace.c	Tue Nov 21 01:49:30 2000
+++ ircd-pi1.0a/src/m_trace.c	Tue May 21 22:14:29 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_trace.c,v 1.3 2000/11/21 06:49:30 lusky Exp $
+ *   $Id: m_trace.c,v 1.3 2002/05/22 02:14:29 smoli Exp $
  */
 #include "m_commands.h"
 #include "class.h"
@@ -33,6 +33,7 @@
 #include "s_bsd.h"
 #include "s_serv.h"
 #include "send.h"
+#include "config.h"
 
 #include <string.h>
 #include <time.h>
@@ -109,8 +110,7 @@
   int   doall, link_s[MAXCONNECTIONS], link_u[MAXCONNECTIONS];
   int   cnt = 0, wilds, dow;
 #ifdef PACE_TRACE
-  static time_t last_trace=0L;
-  static time_t last_used=0L;
+  static time_t last_used = 0L;
 #endif
   static time_t now;
 
@@ -143,7 +143,7 @@
                      version, debugmode, tname, ac2ptr->from->name);
         else
           sendto_one(sptr, form_str(RPL_TRACELINK), me.name, parv[0],
-                     version, debugmode, tname, "ac2ptr_is_NULL!!");
+                     version, debugmode, tname, 0, 0, "ac2ptr_is_NULL!!");
         return 0;
       }
     case HUNTED_ISME:
@@ -155,18 +155,14 @@
   if(!IsAnOper(sptr))
     {
       /* pacing for /trace is problemmatical */
-#if PACE_TRACE
-      if((last_used + PACE_WAIT) > CurrentTime)
+#ifdef PACE_TRACE
+      if(MyClient(sptr) && (last_used + PACE_WAIT) > CurrentTime)
         {
-          /* safe enough to give this on a local connect only */
-          if(MyClient(sptr))
-            sendto_one(sptr,form_str(RPL_LOAD2HI),me.name,parv[0]);
+          sendto_one(sptr,form_str(RPL_LOAD2HI),me.name,parv[0]);
           return 0;
         }
       else
-        {
-          last_used = CurrentTime;
-        }
+        last_used = CurrentTime;
 #endif
 
       if (parv[1] && !strchr(parv[1],'.') && (strchr(parv[1], '*')
diff -uNrd ircd-hybrid-6.0/src/m_ungline.c ircd-pi1.0a/src/m_ungline.c
--- ircd-hybrid-6.0/src/m_ungline.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/m_ungline.c	Sun May  5 00:42:24 2002
@@ -0,0 +1,140 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_ungline.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *
+ *   $Id: m_ungline.c,v 1.4 2002/05/05 04:42:24 smoli Exp $
+ */
+#include "m_commands.h"
+#include "channel.h"
+#include "client.h"
+#include "common.h"
+#include "dline_conf.h"
+#include "fileio.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "mtrie_conf.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_misc.h"
+
+#include "send.h"
+#include "struct.h"
+
+#include <stdio.h>
+#include <time.h>
+#include <string.h>
+#include <unistd.h>
+
+#ifdef GLINES
+
+extern ConfigFileEntryType ConfigFileEntry;
+extern int    remove_gline_match(char *host,char *user);
+
+/*
+ * m_ungline
+ *
+ *      parv[0] = sender
+ *      parv[1] = address to remove
+ *
+ */
+int m_ungline (aClient *cptr,aClient *sptr,int parc,char *parv[])
+{
+  char  *user,*host;
+
+  if (check_registered(sptr))
+    {
+      return -1;
+    }
+
+  if (!IsAnOper(sptr))
+    {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name,
+                 parv[0]);
+      return 0;
+    }
+
+  if (!IsSetOperUnkline(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :You have no U flag",me.name,parv[0]);
+      return 0;
+    }
+
+  if ( parc < 2 )
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "UNGLINE");
+      return 0;
+    }
+
+  if ( (host = strchr(parv[1], '@')) || *parv[1] == '*' )
+    {
+      // Explicit user@host mask given
+
+      if(host)
+        {
+          user = parv[1];       // here is user part
+          *(host++) = '\0';     // and now here is host
+        }
+      else
+        {
+          user = "*";           // no @ found, assume its *@somehost
+          host = parv[1];
+        }
+    }
+  else
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Invalid parameters",
+                 me.name, parv[0]);
+      return 0;
+    }
+
+  if( (user[0] == '*') && (user[1] == '\0')
+      && (host[0] == '*') && (host[1] == '\0') )
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Cannot UNG-Line everyone",
+                 me.name, parv[0]);
+      return 0;
+    }
+
+  if(remove_gline_match(host,user))
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Un-glined [%s@%s] from g-lines",
+                 me.name, parv[0],user, host);
+      sendto_ops("%s has removed the G-Line for: [%s@%s]",
+                 parv[0], user, host );
+
+      log(L_NOTICE, "%s removed G-Line for [%s@%s]",
+          parv[0], user, host);
+      return 0;
+    }
+  else
+    {
+     sendto_one(sptr, ":%s NOTICE %s :Can't find gline for [%s@%s]",
+                 me.name, parv[0],user, host);
+    }
+
+ return 0;
+}
+
+#endif /* GLINES */
+
diff -uNrd ircd-hybrid-6.0/src/m_unkline.c ircd-pi1.0a/src/m_unkline.c
--- ircd-hybrid-6.0/src/m_unkline.c	Sat Nov 18 14:11:12 2000
+++ ircd-pi1.0a/src/m_unkline.c	Fri Nov  2 19:23:35 2001
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_unkline.c,v 1.39 2000/11/18 19:11:12 lusky Exp $
+ *   $Id: m_unkline.c,v 1.1.1.1 2001/11/03 00:23:35 shifty Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-6.0/src/m_userhost.c ircd-pi1.0a/src/m_userhost.c
--- ircd-hybrid-6.0/src/m_userhost.c	Tue Jan  2 00:48:18 2001
+++ ircd-pi1.0a/src/m_userhost.c	Fri Nov  2 19:23:35 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_userhost.c,v 1.10 2001/01/02 05:48:18 lusky Exp $
+ *   $Id: m_userhost.c,v 1.1.1.1 2001/11/03 00:23:35 shifty Exp $
  */
 
 #include "m_commands.h"
diff -uNrd ircd-hybrid-6.0/src/m_users.c ircd-pi1.0a/src/m_users.c
--- ircd-hybrid-6.0/src/m_users.c	Thu Jul 29 03:11:49 1999
+++ ircd-pi1.0a/src/m_users.c	Fri Nov  2 19:23:35 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_users.c,v 1.1 1999/07/29 07:11:49 tomh Exp $
+ *   $Id: m_users.c,v 1.1.1.1 2001/11/03 00:23:35 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_version.c ircd-pi1.0a/src/m_version.c
--- ircd-hybrid-6.0/src/m_version.c	Sat Jul 31 00:48:04 1999
+++ ircd-pi1.0a/src/m_version.c	Fri Nov  2 19:23:35 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_version.c,v 1.5 1999/07/31 04:48:04 db Exp $
+ *   $Id: m_version.c,v 1.1.1.1 2001/11/03 00:23:35 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_wallops.c ircd-pi1.0a/src/m_wallops.c
--- ircd-hybrid-6.0/src/m_wallops.c	Mon Aug  9 22:46:25 1999
+++ ircd-pi1.0a/src/m_wallops.c	Fri Nov  2 19:23:35 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_wallops.c,v 1.2 1999/08/10 02:46:25 lusky Exp $
+ *   $Id: m_wallops.c,v 1.1.1.1 2001/11/03 00:23:35 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_who.c ircd-pi1.0a/src/m_who.c
--- ircd-hybrid-6.0/src/m_who.c	Fri Nov 24 12:36:30 2000
+++ ircd-pi1.0a/src/m_who.c	Thu May 23 00:22:22 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_who.c,v 1.3 2000/11/24 17:36:30 lusky Exp $
+ *   $Id: m_who.c,v 1.3 2002/05/23 04:22:22 smoli Exp $
  */
 
 #include "m_commands.h"
@@ -97,14 +97,22 @@
                        struct Channel *repchan,
                        Link *lp)
 {
-  char  status[5];
+  char  status[6];
   /* Using a pointer will compile faster than an index */
   char *p = status;
 
-  if (acptr->user->away)
+#ifdef ENFORCE
+  if(IsEnforce(acptr))
+    *p++ = 'E';
+#endif
+  if(acptr->user->away)
     *p++ = 'G';
   else
     *p++ = 'H';
+#ifdef HAVE_SSL
+  if(IsSSLUmode(acptr))
+    *p++ = 'S';
+#endif
   if (IsAnOper(acptr))
     *p++ = '*';
   if ((repchan != NULL) && (lp == NULL))
@@ -158,6 +166,7 @@
   int   oper = parc > 2 ? (*parv[2] == 'o' ): 0; /* Show OPERS only */
   int   member;
   int   maxmatches = 500;
+  int   enforced = 0;
 
   mychannel = NullChn;
   if (sptr->user)
@@ -200,6 +209,9 @@
       if (chptr)
         {
           member = IsMember(sptr, chptr);
+          if(!member && IsEnforce(sptr))
+            enforced = ++member;
+
           if (member || !SecretChannel(chptr))
             for (lp = chptr->members; lp; lp = lp->next)
               {
@@ -209,7 +221,11 @@
                   continue;
                 do_who(sptr, lp->value.cptr, chptr, lp);
               }
+          if(enforced && MyClient(sptr) && !IsServer(sptr))
+            sendto_realops("Enforced who for %s from %s (%s@%s)",
+                           parv[1], sptr->name, sptr->username, sptr->host);
         }
+      
     }
   else if (mask && 
            ((acptr = find_client(mask, NULL)) != NULL) &&
@@ -223,6 +239,9 @@
         {
           chptr = lp->value.chptr;
           member = IsMember(sptr, chptr);
+          if(!member && IsEnforce(sptr))
+            enforced = ++member;
+
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
@@ -231,6 +250,11 @@
               break;
             }
         }
+      if(parv[1] && *parv[1] != '-')
+        if(enforced && MyClient(sptr) && !IsServer(sptr))
+           sendto_realops("Enforced who for %s from %s (%s@%s)",
+                          parv[1], sptr->name, sptr->username, sptr->host);
+
       do_who(sptr, acptr, ch2ptr, NULL);
     }
   else for (acptr = GlobalClientList; acptr; acptr = acptr->next)
@@ -256,6 +280,9 @@
         {
           chptr = lp->value.chptr;
           member = IsMember(sptr, chptr);
+          if(!member && IsEnforce(sptr))
+            enforced = ++member;
+
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
@@ -268,6 +295,11 @@
               !isinvis)
             showperson = 1;
         }
+      if(parv[1] && *parv[1] != '-')
+        if(enforced && MyClient(sptr) && !IsServer(sptr))
+          sendto_realops("Enforced who for %s from %s (%s@%s)",
+                         parv[1], sptr->name, sptr->username, sptr->host);
+
       if (!acptr->user->channel && !isinvis)
         showperson = 1;
       if (showperson &&
diff -uNrd ircd-hybrid-6.0/src/m_whois.c ircd-pi1.0a/src/m_whois.c
--- ircd-hybrid-6.0/src/m_whois.c	Fri Nov 24 12:36:30 2000
+++ ircd-pi1.0a/src/m_whois.c	Sat May 18 00:05:58 2002
@@ -1,5 +1,5 @@
 /************************************************************************
- *   IRC - Internet Relay Chat, src/m_who.c
+ *   IRC - Internet Relay Chat, src/m_whois.c
  *   Copyright (C) 1990 Jarkko Oikarinen and
  *                      University of Oulu, Computing Center
  *
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_whois.c,v 1.6 2000/11/24 17:36:30 lusky Exp $
+ *   $Id: m_whois.c,v 1.7 2002/05/18 04:05:58 smoli Exp $
  */
 
 #include "m_commands.h"
@@ -34,6 +34,8 @@
 #include "send.h"
 #include "list.h"
 #include "irc_string.h"
+#include "s_log.h"
+#include "setup.h"
 
 #include <string.h>
 
@@ -113,6 +115,8 @@
     NULL,       /* invited */
     NULL,       /* away */
     0,          /* last */
+    0,          /* last sent */
+    0,          /* spoofed */
     1,          /* refcount */
     0,          /* joined */
     "<Unknown>"         /* server */
@@ -126,6 +130,7 @@
   char  *p = NULL;
   int   found, len, mlen;
   static time_t last_used=0L;
+  static int use_count = 0;
   int found_mode;
 
   if (parc < 2)
@@ -137,9 +142,10 @@
 
   if(parc > 2)
     {
-      if (hunt_server(cptr,sptr,":%s WHOIS %s :%s", 1,parc,parv) !=
-          HUNTED_ISME)
-        return 0;
+      if(!MyConnect(sptr))
+        if(hunt_server(cptr,sptr,":%s WHOIS %s :%s", 1,parc,parv) !=
+            HUNTED_ISME)
+          return 0;
       parv[1] = parv[2];
     }
 
@@ -151,11 +157,13 @@
            * request =might= increase sendq to be usable in a split hack
            * Sorry gang ;-( - Dianora
            */
-          return 0;
+          if(use_count++ > 5)
+            return 0;
         }
       else
         {
           last_used = CurrentTime;
+          use_count = 0;
         }
     }
 
@@ -217,25 +225,45 @@
             /*      continue; */
 
           user = acptr->user ? acptr->user : &UnknownUser;
-          name = (!*acptr->name) ? "?" : acptr->name;
+          if(!*acptr->name)
+            {
+              static char q[] = "?";
+              sendto_realops_lev(L_DEBUG, "hash_find_client(%s, NULL) returnedd me client %p, with 0-length name",
+                                          nick, (void *)acptr);
+              name = q;
+            }
+          else
+            name = acptr->name;
+          
           invis = IsInvisible(acptr);
           member = (user->channel) ? 1 : 0;
 
           a2cptr = find_server(user->server);
+
+          if(!MyClient(acptr) && IsCapable(a2cptr->from,CAP_RW) && acptr->name)
+            {
+              sendto_one(a2cptr, ":%s WHOIS %s", sptr->name, acptr->name);
+/*              if(acptr->user)   
+                sendto_one(sptr, form_str(RPL_WHOISIDLE),
+                me.name, parv[0], name, CurrentTime - user->last,
+                acptr->firsttime);*/
+              
+              return 0;
+            }
           
           sendto_one(sptr, form_str(RPL_WHOISUSER), me.name,
                      parv[0], name,
                      acptr->username, acptr->host, acptr->info);
 
-          mlen = strlen(me.name) + strlen(parv[0]) + 6 +
-            strlen(name);
+          mlen = irclen(me.name) + irclen(parv[0]) + 6 +
+            irclen(name);
           for (len = 0, *buf = '\0', lp = user->channel; lp;
                lp = lp->next)
             {
               chptr = lp->value.chptr;
               if (ShowChannel(sptr, chptr))
                 {
-                  if (len + strlen(chptr->chname)
+                  if (len + irclen(chptr->chname)
                       > (size_t) BUFSIZE - 4 - mlen)
                     {
                       sendto_one(sptr,
@@ -260,7 +288,7 @@
                   if (len)
                     *(buf + len) = '\0';
                   (void)strcpy(buf + len, chptr->chname);
-                  len += strlen(chptr->chname);
+                  len += irclen(chptr->chname);
                   (void)strcat(buf + len, " ");
                   len++;
                 }
@@ -287,6 +315,16 @@
           if (IsAnOper(acptr))
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
                        me.name, parv[0], name);
+#ifdef ENFORCE
+	  if (IsEnforce(acptr))
+	    sendto_one(sptr, form_str(RPL_WHOISENFORCE),
+		       me.name, parv[0], name);
+#endif /* ENFORCE */
+#ifdef HAVE_SSL
+	  if (IsSSLUmode(acptr))
+	    sendto_one(sptr, form_str(RPL_WHOISSSL),
+		       me.name, parv[0], name);
+#endif /* HAVE_SSL */
 #ifdef WHOIS_NOTICE
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
               (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
@@ -371,15 +409,15 @@
                      parv[0], name,
                      acptr->username, acptr->host, acptr->info);
           found = 1;
-          mlen = strlen(me.name) + strlen(parv[0]) + 6 +
-            strlen(name);
+          mlen = irclen(me.name) + irclen(parv[0]) + 6 +
+            irclen(name);
           for (len = 0, *buf = '\0', lp = user->channel; lp;
                lp = lp->next)
             {
               chptr = lp->value.chptr;
               if (ShowChannel(sptr, chptr))
                 {
-                  if (len + strlen(chptr->chname)
+                  if (len + irclen(chptr->chname)
                       > (size_t) BUFSIZE - 4 - mlen)
                     {
                       sendto_one(sptr,
@@ -403,7 +441,7 @@
                   if (len)
                     *(buf + len) = '\0';
                   (void)strcpy(buf + len, chptr->chname);
-                  len += strlen(chptr->chname);
+                  len += irclen(chptr->chname);
                   (void)strcat(buf + len, " ");
                   len++;
                 }
@@ -430,6 +468,12 @@
           if (IsAnOper(acptr))
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
                        me.name, parv[0], name);
+#ifdef ENFORCE
+	  if (IsEnforce(acptr))
+	    sendto_one(sptr, form_str(RPL_WHOISENFORCE),
+		       me.name, parv[0], name);
+#endif /* ENFORCE */
+	   
 #ifdef WHOIS_NOTICE
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
               (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
